/* ANSI-C code produced by gperf version 2.7.2 */
/* Command-line: gperf -E -L ANSI-C -I -H token_hash -N sieve_token -C -o -k '1,2,$' -t identifier.gperf  */
struct identifier;
#include <string.h>
/* maximum key range = 65, duplicates = 0 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
token_hash (register const char *str, register unsigned int len)
{
  static const unsigned char asso_values[] =
    {
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69,  0, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 20, 69, 15,
       5,  0,  0, 69, 10, 10, 69, 15,  5, 10,
      10, 45, 35, 69,  0, 25,  0, 35, 25, 69,
       5, 25, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
      69, 69, 69, 69, 69, 69
    };
  return len + asso_values[(unsigned char)str[1]] + asso_values[(unsigned char)str[0]] + asso_values[(unsigned char)str[len - 1]];
}

#ifdef __GNUC__
__inline
#endif
const struct identifier *
sieve_token (register const char *str, register unsigned int len)
{
  enum
    {
      TOTAL_KEYWORDS = 38,
      MIN_WORD_LENGTH = 2,
      MAX_WORD_LENGTH = 11,
      MIN_HASH_VALUE = 4,
      MAX_HASH_VALUE = 68
    };

  static const struct identifier wordlist[] =
    {
      {""}, {""}, {""}, {""},
      {"true",       SIEVE_TRUE},
      {"text:",      SIEVE_TEXT},
      {"reject",     SIEVE_REJECT},
      {"require",    SIEVE_REQUIRE},
      {"redirect",   SIEVE_REDIRECT},
      {"else",       SIEVE_ELSE},
      {"elsif",      SIEVE_ELSIF},
      {":regex",     SIEVE_REGEX},
      {"if",	    SIEVE_IF},
      {""}, {""},
      {":localpart", SIEVE_LOCALPART},
      {"header",     SIEVE_HEADER},
      {":detail",    SIEVE_DETAIL},
      {"envelope",   SIEVE_ENVELOPE},
      {""}, {""},
      {":count",     SIEVE_COUNT},
      {":domain",    SIEVE_DOMAIN},
      {""}, {""},
      {"false",      SIEVE_FALSE},
      {":comparator",SIEVE_COMPARATOR},
      {"discard",    SIEVE_DISCARD},
      {""},
      {":all",       SIEVE_ALL},
      {"allof",      SIEVE_ALLOF},
      {":value",     SIEVE_VALUE},
      {""}, {""}, {""},
      {"anyof",      SIEVE_ANYOF},
      {"exists",     SIEVE_EXISTS},
      {""},
      {":is",        SIEVE_IS},
      {"size",       SIEVE_SIZE},
      {":user",      SIEVE_USER},
      {":under",     SIEVE_UNDER},
      {""},
      {":matches",   SIEVE_MATCHES},
      {"virustest",  SIEVE_VIRUSTEST},
      {":copy",      SIEVE_COPY},
      {""}, {""}, {""},
      {":contains",  SIEVE_CONTAINS},
      {":over",      SIEVE_OVER},
      {""}, {""}, {""},
      {"keep",       SIEVE_KEEP},
      {""}, {""},
      {"address",    SIEVE_ADDRESS},
      {"not",        SIEVE_NOT},
      {""}, {""}, {""}, {""},
      {"fileinto",   SIEVE_FILEINTO},
      {"stop",       SIEVE_STOP},
      {""}, {""}, {""},
      {"spamtest",   SIEVE_SPAMTEST}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = token_hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register const char *s = wordlist[key].name;

          if (*str == *s && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}
