#! /bin/sh
# $Id: lmtpsend.sh,v 1.4 2004/06/29 10:55:57 lwa Exp $

# dummy lmtp client who send command stdout
# get recipents from argument list
# and read message from stdin
# output may be piped to lmtpd but no error is checked.

from=""
args=`getopt f: $@`

if test $? != 0
then
  echo "usage: $0 [ -f from ] user1 ..." >&2
  exit 2
fi

set -- $args
for i 
do
case "$i" in
-f) shift; from="$1"; shift;;
--) shift; break;;
esac
done

if test $# = 0
then
  echo "usage: $0 [ -f from ] user1 ..." >&2
  exit 1
fi

echo LHLO `hostname`
echo "MAIL FROM:<$from>"
for user in "$@"
  do
  echo "RCPT TO:<$user>"
  done
echo DATA
sed "s/^\./../"
echo .
echo QUIT

exit 0
